#include <math.h>
#include <iostream>
using namespace std;

double binom(int n,int k) {
	double result=1;
	for(int j=0;j<k;j++) {
		result*=(n-j)/(double)(k-j);
	}
	return result;
}

double pVal(int n,int correct) {
	double result=0.0;
	double binom;
	int twos;
	for(int k=correct;k<=n;k++) {
		twos=n;
		binom=1;
		for(int j=0;j<k;j++) {
			binom*=(n-j)/(double)(k-j);
			while(binom>2 && twos>0){binom/=2;--twos;}
		}
		for(int j=0;j<twos;j++){binom/=2;}
		result+=binom;
	}
	return result;
}

double cVal(int depth,int numTrials,int correct) {
	if(correct==0){return 1.0;}
	if(depth==1) {
		return pVal(numTrials,correct);
	}
	double currentVal=cVal(depth-1,numTrials,correct);
	cout << "currentVal=" << currentVal << "\n";
	double result=0.0;
	int n=0,k=0,m=0;
	int* cappedBinoms=new int[numTrials+1];
	cappedBinoms[0]=1;
	while(n<numTrials) {
		while(cVal(depth-1,n,k)>currentVal){n++;k++;m++;}
		cout << "stop point at: n=" << n << ", k=" << k << ", m="<<m<<"\n";
		cout << "cappedBinoms=";
		for(int i=0;i<numTrials+1;i++){cout << cappedBinoms[i] << "   ";}
		cout << "\n";
		cout << "result="<<result<<"\n";
		result+=cappedBinoms[k-m]*pow(2.0,-n);
		for(int i=n-m+1;i<=n;i++) {
			cappedBinoms[i]=cappedBinoms[i-1];
			for(int j=i-1;j>0;j--) {
				cappedBinoms[j]=cappedBinoms[j]+cappedBinoms[j-1];
			}
		}
		for(int i=k;i<=n;i++){cappedBinoms[i]=0;}
		cout << "new result="<<result<<"\n";
		cout << "new cappedBinoms=";
		for(int i=0;i<numTrials+1;i++){cout << cappedBinoms[i] << "   ";}
		cout << "\n";
		m=0;
		k--;
	}
	return result;
}

int main(int nArg, char* pszArgs[]) {
	int correct,numTrials,depth;
	/*for(depth=1;depth<10;depth++) {
		for(int i=0;i<10;i++) {
			for(int j=0;j<=i;j++) {
				cout<<cVal(depth,i,j)<<"\t";
			}
			cout<<"\n";
		}
		cout << "\n\n";
	}*/
	while(true) {
		cout << "Total trials: ";
		cin >> numTrials;
		if(numTrials<1){break;}
		cout << "Correct: ";
		cin >> correct;
		if(correct<0){break;}
		cout << "Depth: ";
		cin >> depth;
		if(depth<1){break;}
		cout << cVal(depth,numTrials,correct) << "\n";
	}
	return 0;
}
